VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "OutAddIn"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
'*************************************************************************
'Items Command Bar
'Sample Outlook 2000 COM Add-in application
'Provided by Micro Eye, Inc.
'http://www.microeye.com
'You can modify this COM Add-in project to suit your own requirements
'No support is provided for this sample COM Add-in project
'Purpose: Demonstrate a simple COM Add-in built using Outlook 2000
'Class: OutAddIn
'Instancing: MultiUse
'Public Events:
'Public Functions:
'Public Properties:
'*************************************************************************
'Object variables for Event procedures
Private WithEvents objOutlook As Outlook.Application
Attribute objOutlook.VB_VarHelpID = -1
Private WithEvents objExpl As Outlook.Explorer
Attribute objExpl.VB_VarHelpID = -1
Private WithEvents colExpl As Outlook.Explorers
Attribute colExpl.VB_VarHelpID = -1
'Use gstrProgID to set the OnAction property of CB buttons
Private gstrProgID As String
'Declare CommandBar, CommandBarButton, and CommandBarComboBox object variables here
'Private WithEvents CBBMyButton As Office.CommandBarButton
'CommandBar object variables for Items Toolbar
Private cbrNewToolbar As Office.CommandBar
Private WithEvents CBBMail As Office.CommandBarButton
Attribute CBBMail.VB_VarHelpID = -1
Private WithEvents CBBPost As Office.CommandBarButton
Attribute CBBPost.VB_VarHelpID = -1
Private WithEvents CBBAppt As Office.CommandBarButton
Attribute CBBAppt.VB_VarHelpID = -1
Private WithEvents CBBMtgRequest As Office.CommandBarButton
Attribute CBBMtgRequest.VB_VarHelpID = -1
Private WithEvents CBBContact As Office.CommandBarButton
Attribute CBBContact.VB_VarHelpID = -1
Private WithEvents CBBDistList As Office.CommandBarButton
Attribute CBBDistList.VB_VarHelpID = -1
Private WithEvents CBBJournal As Office.CommandBarButton
Attribute CBBJournal.VB_VarHelpID = -1
Private WithEvents CBBTask As Office.CommandBarButton
Attribute CBBTask.VB_VarHelpID = -1
Private WithEvents CBBTaskRequest As Office.CommandBarButton
Attribute CBBTaskRequest.VB_VarHelpID = -1
Private WithEvents CBBNote As Office.CommandBarButton
Attribute CBBNote.VB_VarHelpID = -1
Private WithEvents CBBWordMail As Office.CommandBarButton
Attribute CBBWordMail.VB_VarHelpID = -1
Private WithEvents CBBExcelMail As Office.CommandBarButton
Attribute CBBExcelMail.VB_VarHelpID = -1
Private WithEvents CBBPPTMail As Office.CommandBarButton
Attribute CBBPPTMail.VB_VarHelpID = -1
Private WithEvents CBBDocument As Office.CommandBarButton
Attribute CBBDocument.VB_VarHelpID = -1
Private WithEvents CBBChooseForm As Office.CommandBarButton
Attribute CBBChooseForm.VB_VarHelpID = -1
Private WithEvents CBBForm As Office.CommandBarComboBox
Attribute CBBForm.VB_VarHelpID = -1

Friend Sub InitHandler(olApp As Outlook.Application, strProgID As String)
    On Error Resume Next
    'Declared WithEvents
    Set objOutlook = olApp
    'Instantiate a public module-level Outlook application variable
    Set golApp = olApp
    'Declared WithEvents
    gstrProgID = strProgID
    Set colExpl = objOutlook.Explorers
    Set objExpl = objOutlook.ActiveExplorer
    Set gobjCDO = CreateObject("MAPI.Session")
    gobjCDO.Logon "", "", False, False
    CBOutlookItems objExpl.CurrentFolder
End Sub

Friend Sub UnInitHandler()
    'You must dereference all objects in this procedure
    'or Outlook will remain in memory
    'If you have created an objMailItem variable,
    'be sure to Set objMailItem = Nothing in this procedure
    On Error Resume Next
    Set objExpl = Nothing
    Set colExpl = Nothing
    Set golApp = Nothing
    Set objOutlook = Nothing
    gobjCDO.Logoff
    Set gobjCDO = Nothing
End Sub

Private Sub CBBAppt_Click(ByVal Ctrl As Office.CommandBarButton, CancelDefault As Boolean)
    CreateAppt
End Sub

Private Sub CBBChooseForm_Click(ByVal Ctrl As Office.CommandBarButton, CancelDefault As Boolean)
    CreateForm
End Sub

Private Sub CBBContact_Click(ByVal Ctrl As Office.CommandBarButton, CancelDefault As Boolean)
    CreateContact
End Sub

Private Sub CBBDistList_Click(ByVal Ctrl As Office.CommandBarButton, CancelDefault As Boolean)
    CreateDistList
End Sub

Private Sub CBBDocument_Click(ByVal Ctrl As Office.CommandBarButton, CancelDefault As Boolean)
    CreateDocument
End Sub

Private Sub CBBExcelMail_Click(ByVal Ctrl As Office.CommandBarButton, CancelDefault As Boolean)
    LaunchExcelMail
End Sub

Private Sub CBBForm_Change(ByVal Ctrl As Office.CommandBarComboBox)
    cmdCreateForm
End Sub

Private Sub CBBJournal_Click(ByVal Ctrl As Office.CommandBarButton, CancelDefault As Boolean)
    CreateJournal
End Sub

Private Sub CBBMail_Click(ByVal Ctrl As Office.CommandBarButton, CancelDefault As Boolean)
    CreateMail
End Sub

Private Sub CBBMtgRequest_Click(ByVal Ctrl As Office.CommandBarButton, CancelDefault As Boolean)
    CreateMtgRequest
End Sub

Private Sub CBBNote_Click(ByVal Ctrl As Office.CommandBarButton, CancelDefault As Boolean)
    CreateNote
End Sub

Private Sub CBBPost_Click(ByVal Ctrl As Office.CommandBarButton, CancelDefault As Boolean)
    CreatePost
End Sub

Private Sub CBBPPTMail_Click(ByVal Ctrl As Office.CommandBarButton, CancelDefault As Boolean)
    LaunchPowerPointMail
End Sub

Private Sub CBBTask_Click(ByVal Ctrl As Office.CommandBarButton, CancelDefault As Boolean)
    CreateTask
End Sub

Private Sub CBBTaskRequest_Click(ByVal Ctrl As Office.CommandBarButton, CancelDefault As Boolean)
    CreateTaskRequest
End Sub

Private Sub CBBWordMail_Click(ByVal Ctrl As Office.CommandBarButton, CancelDefault As Boolean)
    LaunchWordMail
End Sub

'Use the Outlook 2000 BeforeFolderSwitch event to populate the custom form drop-down
'on the Items Command Bar
Private Sub objExpl_BeforeFolderSwitch(ByVal NewFolder As Object, Cancel As Boolean)
    On Error Resume Next
    If NewFolder Is Nothing Then 'Handle file system folder
        CBBPost.Visible = False
        CBBForm.Visible = False
        Exit Sub
    End If
    Call CBOutlookItems(NewFolder)
End Sub

'Due to MAPI issues, On_Disconnection might not fire during Outlook shutdown
'Call UnInitHandler in objExpl_Close event
Private Sub objExpl_Close()
    If objOutlook.Explorers.Count <= 1 Then
        Call UnInitHandler
    End If
End Sub

Private Sub objOutlook_Startup()
    On Error Resume Next
    'Handle the case when there is no Explorer object
    'Send To Mail Recipient MAPI causes this condition
    'when Outlook is not running
    If colExpl.Count Then
        Call CBOutlookItems(objExpl.CurrentFolder)
    End If
End Sub

'*************************************************************
'Procedure: CBOutlookItems(objFolder as Outlook.MAPIFolder)
'Purpose: Update Items CB with application folder forms
'Argument: MAPIFolder object
'Usage: 'Call this procedure in objExpl_BeforeFolderSwitch
'Returns: n/a
'*************************************************************
Private Sub CBOutlookItems(ByVal objFolder As Outlook.MAPIFolder)
    Dim intCount As Integer
    Dim i As Integer
    Dim blnNew As Boolean
    Dim CBBTest

    ' Test if the Items toolbar already exists
    On Error Resume Next
    Set cbrNewToolbar = golApp.ActiveExplorer.CommandBars("Items")
    If Err Then
        blnNew = True
        ' Create a new items toolbar.
        Set cbrNewToolbar = golApp.ActiveExplorer.CommandBars.Add _
            (Name:="Items", Position:=msoBarTop, Temporary:=False)
    Else
        Set CBBTest = cbrNewToolbar.FindControl(Tag:="")
        If CBBTest Is Nothing Then
            'Do nothing since this toolbar is not from VBAProject.OTM in BAO2K
        Else
            'Delete existing buttons
            Do Until cbrNewToolbar.Controls.Count = 0
                cbrNewToolbar.Controls.Item(1).Delete
            Loop
        End If
    End If
    Set CBBMail = CreateAddInCommandBarButton(gstrProgID, cbrNewToolbar, _
        "New Mail Message", "New Mail Message", "New Mail Message", 1757, False, msoButtonIcon)
    Set CBBPost = CreateAddInCommandBarButton(gstrProgID, cbrNewToolbar, _
        "New Post in this Folder", "New Post in this Folder", "New Post in this Folder", 2687, False, msoButtonIcon)
    Select Case objFolder.DefaultItemType
        Case olMailItem
        CBBPost.Visible = True
        Case olPostItem
        CBBPost.Visible = True
        Case Else
        CBBPost.Visible = False
    End Select
    Set CBBWordMail = CreateAddInCommandBarButton(gstrProgID, cbrNewToolbar, _
        "HTML Word Mail", "HTML Word Mail", "HTML Word Mail", 42, True, msoButtonIcon)
    Set CBBExcelMail = CreateAddInCommandBarButton(gstrProgID, cbrNewToolbar, _
        "HTML Excel Mail", "HTML Excel Mail", "HTML Excel Mail", 263, False, msoButtonIcon)
    Set CBBPPTMail = CreateAddInCommandBarButton(gstrProgID, cbrNewToolbar, _
        "HTML PowerPoint Mail", "HTML PowerPoint Mail", "HTML PowerPoint Mail", 267, False, msoButtonIcon)
    Set CBBAppt = CreateAddInCommandBarButton(gstrProgID, cbrNewToolbar, _
        "New Appointment", "New Appointment", "New Appointment", 1106, True, msoButtonIcon)
    Set CBBMtgRequest = CreateAddInCommandBarButton(gstrProgID, cbrNewToolbar, _
        "Meeting Request", "Meeting Request", "Meeting Request", 1754, False, msoButtonIcon)
    Set CBBContact = CreateAddInCommandBarButton(gstrProgID, cbrNewToolbar, _
        "New Contact", "New Contact", "New Contact", 1099, False, msoButtonIcon)
    Set CBBDistList = CreateAddInCommandBarButton(gstrProgID, cbrNewToolbar, _
        "New Distribution List", "New Distribution List", "New Distribution List", 5435, False, msoButtonIcon)
    Set CBBTask = CreateAddInCommandBarButton(gstrProgID, cbrNewToolbar, _
        "New Task", "New Task", "New Task", 1100, False, msoButtonIcon)
    Set CBBTaskRequest = CreateAddInCommandBarButton(gstrProgID, cbrNewToolbar, _
        "Task Request", "Task Request", "Task Request", 2006, False, msoButtonIcon)
    Set CBBJournal = CreateAddInCommandBarButton(gstrProgID, cbrNewToolbar, _
        "New Journal", "New Journal", "New Journal", 1990, False, msoButtonIcon)
    Set CBBNote = CreateAddInCommandBarButton(gstrProgID, cbrNewToolbar, _
        "New Note", "New Note", "New Note", 1758, False, msoButtonIcon)
    Set CBBDocument = CreateAddInCommandBarButton(gstrProgID, cbrNewToolbar, _
        "New Office Document", "New Office Document", "New Office Document", 2576, False, msoButtonIcon)
    Set CBBChooseForm = CreateAddInCommandBarButton(gstrProgID, cbrNewToolbar, _
        "Choose Form", "Choose Form", "Choose Form", 0, True, msoButtonCaption)
    Set CBBForm = cbrNewToolbar.FindControl(Type:=msoControlDropdown)
    If CBBForm Is Nothing Then
        Set CBBForm = cbrNewToolbar.Controls.Add _
        (Type:=msoControlDropdown)
        CBBForm.Tag = "Custom Form"
    End If
    'GetFormDescriptions returns a variant array with
    'display name and message class for forms published
    'in the application folder. Hidden forms are not available.
    avarForms = GetFormDescriptions(objFolder.EntryID, objFolder.StoreID)
    'No custom forms published in folder
    If avarForms(0, 0) = "" Then
        CBBForm.Visible = False
    Else
        CBBForm.Clear
        For i = 0 To UBound(avarForms, 1)
            CBBForm.AddItem avarForms(i, 0)
        Next
        With CBBForm
            .Enabled = True
            .Visible = True
            .BeginGroup = True
            .Style = msoComboLabel
            .ListIndex = 1
            .Width = 200
            .Caption = "New: "
            .Tag = "New: "
            'Concatenate "!<" & ">" to ProgID
            'Required for COM Add-ins
            .OnAction = "!<" & gstrProgID & ">"
        End With
    End If
    'Display toolbar if new
    If blnNew Then
        cbrNewToolbar.Visible = True
    End If
End Sub

